﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using InfoAPILib;
using System.Diagnostics;

namespace InfoAPIDemoInfo
{
    class Program
    {
        private InfoAPIHandler APIHandler;
        private InfoAPIParams APIParams;

        static void Main(string[] args)
        {
            Stopwatch sw = new Stopwatch();
            sw.Start();
            Program program = new Program();
            program.RunTest();
            Console.WriteLine("\nBenchmark: " + sw.Elapsed.TotalSeconds + " SEC");
            Console.ReadLine();
        }

        public void RunTest()
        {
            InfoAPIParamsINFO mAPIParams = new InfoAPIParamsINFO();
            InfoAPIResponse mResponse = this.ExecuteAPI(mAPIParams);
            if (mResponse != null && mResponse.error_state == "ok")
            {
                PrintAPIResult((InfoAPIResultINFO)mResponse.Result);
            }
        }

        public InfoAPIResponse ExecuteAPI(InfoAPIParams pAPIParams)
        {
            this.APIParams = pAPIParams;
            this.PrepareAPICall();

            // IZVRSI POZIV API FUNKCIJE
            // u mAPIResponse se nalazi odgovor API-ja. U mAPIResponse.Result je rezultat izvrsenja funkcije.
            InfoAPIResponse mAPIResponse = null;

            try
            {
                //mAPIResponse = APIHandler.CallAPI(pAPIParams, pAPIResult);
                mAPIResponse = APIHandler.CallAPI(pAPIParams);
            }
            catch (InfoAPICallException e)
            {
                Console.WriteLine("Greska:\r\n" + e.ErrorInfo.error_state + "\r\n" + e.ErrorInfo.error_message);
                Console.WriteLine("API call error!");
            }
            finally
            {

            }
            return mAPIResponse;
        }




        private void PrepareAPICall()
        {
            // podešavanje hendlera API konekcije
            this.APIHandler = new InfoAPIHandler();
            this.APIHandler.APIServerURL = "http://apitest.infosys.rs:31000/InfoAPI.aspx";
            this.APIHandler.username = "info";
            this.APIHandler.password = "demo";
            this.APIHandler.client_id = "DEMO";
            this.APIHandler.client_pk = "87oluavs978bl94vkivfzs967zs3rf";
            this.APIHandler.client_version = "0.0.1";
            this.APIHandler.SerializeIdented = true;
            this.APIParams.result_database_format = "PLAIN_OBJ";
        }

        public void PrintAPIResult(InfoAPIResultINFO pResult)
        {
            Console.WriteLine("Generic data\n");
            Console.WriteLine("Error state: " + pResult.error_state);
            Console.WriteLine("Error message: " + pResult.error_message);
            Console.WriteLine("Exec date time: " + pResult.exec_date_time);
            Console.WriteLine("\nResponse Data\n");
            Console.WriteLine("Developer: " + pResult.developer);
            Console.WriteLine("Username: " + pResult.username);
            Console.WriteLine("Logedin: " + pResult.logedin);
            Console.WriteLine("Disk: " + pResult.disk);
            Console.WriteLine("Poslovna godina: " + pResult.poslovna_godina);
            Console.WriteLine("Job: " + pResult.job);
            Console.WriteLine("Pozicija: " + pResult.pozicija);
            Console.WriteLine("Sifra firme: " + pResult.sif_firme);
            Console.WriteLine("Entry name: " + pResult.entry_name);
            Console.WriteLine("Wentry Name: " + pResult.wentry_name);
            Console.WriteLine("Putanja: " + pResult.putanja);
        }

    }
}
