﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InfoAPILib
{
    /// <summary>
    /// Fabrika objekata. Koristi se kao dependency injection da bi InfoAPILib 
    /// mogao da po potrebi kreira objekte za parametre i rezultat API funkcije.
    /// </summary>
    public interface IInfoAPIClassFactory
    {
        /// <summary>
        /// Vrati instanciran odgovarajući parametarski objekat na osnovu naziva API funkcije
        /// </summary>
        /// <param name="pAppOption">Naziv API funkcije</param>
        /// <returns>Instanciran odgovarajući parametarski objekat na osnovu naziva API funkcije</returns>
        InfoAPIParams GetParamsObject(string pAppOption);

        /// <summary>
        /// Vrati instanciran odgovarajući objekat rezultata na osnovu naziva API funkcije
        /// </summary>
        /// <param name="pAppOption">Naziv API funkcije</param>
        /// <returns>Instanciran odgovarajući objekat rezultata na osnovu naziva API funkcije</returns>

        InfoAPIResult GetResultObject(string pAppOption);
    }
}
