﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InfoAPILib
{
    /// <summary>
    /// Interfejs IInfoAPIFormatter obezbeđuje univerzalan mehanizam za serijalizaciju i deserijalizaciju 
    /// kroz dva metoda Serialize<T>() i Deserialize()
    /// 
    /// Na primer, InfoAPIFormatterJSON implementira ovaj interfejs.
    /// </summary>
    public interface IInfoAPIFormatter
    {
        /// <summary>
        /// Metod za serijalizaciju
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="pObject">Objekat koji se serijaliozije</param>
        /// <returns></returns>
        string Serialize<T> (T pObject);
        /// <summary>
        /// Metod za deserijalizaciju
        /// </summary>
        /// <param name="pSerializedInput">String koji se deserijalizuje</param>
        /// <param name="pObject">Objekat u koji se deserijalizuje</param>
        void Deserialize(string pSerializedInput, object pObject);
    }
}
