﻿using System;
using System.Reflection;

namespace InfoAPILib
{

    abstract public class InfoAPIClassFactoryBase: IInfoAPIClassFactory
    {
        public InfoAPIClassFactoryBase()
        {
        }

        public InfoAPIParams GetParamsObject(string pAppOption)
        {
            string lClassName = "InfoAPIParams" + pAppOption;
            InfoAPIParams lResult = (InfoAPIParams)this.GetObject(lClassName);
            return lResult;
        }

        public InfoAPIResult GetResultObject(string pAppOption)
        {
            string lClassName = "InfoAPIResult" + pAppOption.ToUpper();
            InfoAPIResult lResult = (InfoAPIResult)this.GetObject(lClassName);
            return lResult;
        }

        /// <summary>
        /// Kreira objekat po nazivu klase
        /// </summary>
        /// <param name="pClassName">Naziv klase, ne treba da sadrži Namespace</param>
        /// <returns></returns>
        public abstract object GetObject(string pClassName);
    }

}