﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InfoAPILib
{
    public static class InfoAPIEnum
    {


        public static T GetItem<T>(object[] pSource, int pIndex, T pDefaultValue)
        {
            T lResult;
            if (typeof(T).IsArray)
            {
                Type elementType = typeof(T).GetElementType();
                Array array = Array.CreateInstance(elementType, pSource.Length);
                pSource.CopyTo(array, 0);
                T obj = (T)(object)array;
                return obj;
            }
            else
            {
                if (pSource.Length > pIndex)
                {
                    lResult = (T)pSource[pIndex];
                }
                else
                {
                    lResult = (T)pDefaultValue;
                }
                return lResult;
            }
        }

    }
}
