﻿using System;
using Newtonsoft.Json;
using System.Diagnostics;
using Newtonsoft.Json.Linq;
using System.Dynamic;
using System.Collections.Generic;

namespace InfoAPILib
{
    /// <summary>
    /// Serijalizuje i deserijalizuje u JSON formatu
    /// </summary>
    internal class InfoAPIFormatterJSON : IInfoAPIFormatter
    {
        public Formatting Formatting = Formatting.None;
        /// <summary>
        /// Konstruktor
        /// </summary>
        public InfoAPIFormatterJSON()
        {
        }

        /// <summary>
        /// Serializuje objekat u JSON
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="pObject">Objekat koji se serijalizuje</param>
        /// <returns>String koji sadrži serijalizovan objekat</returns>
        
        public string Serialize<T>(T pObject)
        {
            JsonSerializerSettings mSerializerSettings = new JsonSerializerSettings();
            mSerializerSettings.NullValueHandling = NullValueHandling.Ignore;
            mSerializerSettings.DateFormatString = "yyyy'-'MM'-'dd'T'HH':'mm':'ssK";
            return JsonConvert.SerializeObject(pObject, this.Formatting, mSerializerSettings);
        }

        /// <summary>
        /// Deserializuje JSON string u objekat
        /// </summary>
        /// <param name="pSerializedInput">JSON string</param>
        /// <param name="pObject">Objekat u koji se deserijalizuje</param>
        public void Deserialize(string pSerializedInput, object pObject)
        {
            /*
            var mDeserializerSettings = new JsonSerializerSettings
            {
                Error = (sender, args) =>
                {
                    if (Debugger.IsAttached) {
                        Debugger.Break();
                    }
                }
            };

            var mResult = JsonConvert.DeserializeObject<dynamic>(pSerializedInput, mDeserializerSettings);
            */

            //var mResultData = JsonConvert.DeserializeObject<dynamic>(pSerializedInput, mDeserializerSettings);




            if (pObject is IDynamicMetaObjectProvider)
            {

              // ako je dinamicki Result treba nekako prepisati vrednosti u njega.
              // ja sam sad zamni taj objekat sa novi dinamickim objektor dobijenim parsiranjem, ali to 
              // ne valja kao resenje.
              dynamic lResultDynamic = JObject.Parse(pSerializedInput);
              pObject = lResultDynamic;

               /*
                foreach (JProperty lItem in lResultDynamic)
                {
                    //dynamic lRow = lResultDynamic.First();
                    //IDictionary<string, object> lPropertyValues = lItem;
                    //foreach (var lDynamicProperty in lPropertyValues)
                    //{
                    //    //this.AddField(lDynamicProperty.Key, lDynamicProperty.Value.GetType());
                    //}
                    ((DynamicObject)pObject).SetValue();
                }
                */
            } else { 
              JsonConvert.PopulateObject(pSerializedInput, pObject);
            }
        }
    }
}