﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;

namespace InfoAPILib
{
    public class InfoAPIRequest : InfoAPIEnvelope {
        public string accept_encoding { get; internal set; }
        /// <summary>
        /// username(char) 
        /// Корисничко име за пријаву корисника АПИ серверу.Употребљава се
        /// заједно са пољем password.Навођењем корисничког имена и лозинк еу
        /// упиту креира се нова сесија (ако је клијент претходно имао отворену
        /// сесију са АПИ сервером та сесија ће бити затворена) и врши проверу
        /// привилегија и права приступа наведеног корисника.
        /// Када се клијент пријави са корисничким именом и лозинком, биће
        /// отворена нова сесија и надаље клијент у упитима не наводи корисничко
        /// име и лозинку већ идентификатор сесије(и идентификатор инстанце),
        /// осим ако жели да раскине постојећу сесију и започне нову.
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string username { get; set; }
        /// <summary>
        /// password (char) 
        /// Лозинка која се употребљава за пријаву корисника, заједно са username.
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string password { get; set; }
        /// <summary>
        /// client_id (char) 
        /// Ознака клијентског програма (везано за лиценцу)
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string client_id { get; set; }

        /// <summary>
        /// client_version (char) 
        /// Ознака верзије клијентског програма
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string client_version { get; set; }

        public void SetChecksum(string pPrivateKey) {
            this.checksum = this.GetChecksum(this.data, this.req_id, pPrivateKey).ToUpper();
        }
        
    }
}
