﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;

namespace InfoAPILib
{
    public class InfoAPIResponse : InfoAPIEnvelope
    {
        public const string ERROR_STATE_OK = "ok";
        public const string ERROR_STATE_CARDINAL = "cardinal";

        [DataMember(EmitDefaultValue = false)]
        public string disk { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string sif_firme { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string mesto { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string referent { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string error_state { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string error_message { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string result_error_state { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string result_error_message { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string debug_log { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public string requested_accept_encoding { get; protected set; }

        public InfoAPIResult Result { get; internal set; }

        public bool ValidateChecksum(string pPrivateKey)
        {
            return this.checksum.ToLower() == this.GetChecksum(this.data, this.req_id, pPrivateKey);
        }

        public bool isResultStateOK()
        {
            return (this.error_state.ToUpper() == "OK");
        }
    }
}
