﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;

namespace InfoAPILib
{


    /// <summary>
    /// InfoAPIResult klasa obezbeđuje funkcionalnost rezultata koji se dobijaju prilikom poziva API funkciji.
    /// Treba napraviti klasu koja nasleđuje ovu klasu i podesiti je za poziv konkretne API funkcije
    /// </summary>
    public class InfoAPIResult : InfoAPIProperties {

        public const string ERROR_STATE_OK = "ok";

        public InfoAPIResponse ResponseEnvelope { get; set; }

        [DataMember(EmitDefaultValue = false)]
        public string error_state { get; private set; }

        [DataMember(EmitDefaultValue = false)]
        public string error_message { get; protected set; }

        [DataMember(EmitDefaultValue = false)]
        public object error_data { get; private set; }

        [DataMember(EmitDefaultValue = false)]
        public int paging_rec_count { get; private set; }

        [DataMember(EmitDefaultValue = false)]
        public DateTime exec_date_time { get; private set; }

        public InfoAPIAttachments GetAttachments()
        {
            return this.Attachments;
        }

        //public InfoAPIAttachment GetAttachment(string pAttachmentId)
        //{
        //    return this.Attachments[pAttachmentId];
        //}

        public InfoAPITableReference GetTableReference(string pTableName)
        {
            return this.TableReferences.GetTableReference(pTableName);
        }

        public string GetDatabaseFileExtension()
        {
            string mResult = "";

            switch (this.database_format)
            {
                case "PLAIN_OBJ":
                    mResult = "json";
                    break;
                case "SQLITE":
                    mResult = "sqlite";
                    break;
                case "ZIPDBF":
                    mResult = "zip";
                    break;
                default:
                    mResult = "dat";
                    break;

            }
            return mResult;
        }
    }
}
