﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization;
using System.Dynamic;
using System.Linq.Expressions;
using System.Reflection;

namespace InfoAPILib
{
    /// <summary>
    /// InfoAPIResultINFO je primer klase koja predstavlja strukturu podataka u rezultatu izvršavanja
    /// API funkcije INFO.
    /// </summary>
    public class InfoAPIResultUniversal : InfoAPIResult, IDynamicMetaObjectProvider
    {

        IDynamicMetaObjectProvider component = new ExpandoObject();

        public DynamicMetaObject GetMetaObject(Expression parameter)
        {
            return new DelegatingMetaObject(parameter, this, nameof(component));
        }

    }


    class DelegatingMetaObject : DynamicMetaObject
    {
        private readonly DynamicMetaObject innerMetaObject;

        public DelegatingMetaObject(Expression expression, object outerObject, string innerFieldName)
            : base(expression, BindingRestrictions.Empty, outerObject)
        {
            FieldInfo innerField = outerObject.GetType().GetField(innerFieldName, BindingFlags.Instance | BindingFlags.NonPublic);
            var innerObject = innerField.GetValue(outerObject);
            var innerDynamicProvider = innerObject as IDynamicMetaObjectProvider;
            innerMetaObject = innerDynamicProvider.GetMetaObject(Expression.Field(Expression.Convert(Expression, LimitType), innerField));
        }

        public override DynamicMetaObject BindInvokeMember(InvokeMemberBinder binder, DynamicMetaObject[] args)
        {
            return binder.FallbackInvokeMember(this, args, innerMetaObject.BindInvokeMember(binder, args));
        }
    }

}