﻿using System.Collections.Generic;
using System.Runtime.Serialization;

namespace InfoAPILib
{

    [DataContract]
    public class InfoAPITableReferences
    {

        [DataMember(EmitDefaultValue = false)]
        public int count {
            get { return this.items.Count; }
            private set { }
        }

        [DataMember(EmitDefaultValue = false)]
        public string _class_name { get; set; }

        [DataMember(EmitDefaultValue = false)]
        public List<InfoAPITableReference> items { get; set; }

        public bool ShouldSerializeitems()
        {
            return this.items.Count > 0;
        }

        private Dictionary<string, InfoAPITableReference> ItemsDictionary;

        public InfoAPITableReferences()
        {
            this.items = new List<InfoAPITableReference>();
            this.ItemsDictionary = new Dictionary<string, InfoAPITableReference>();
        }


        public void Add(string pTableName, IEnumerable<object> pTableData)
        {
            InfoAPITableReference lTableReference = new InfoAPITableReference();
            lTableReference.table_name = pTableName;
            lTableReference.SetData(pTableData);
            this.items.Add(lTableReference);
            this.ItemsDictionary.Add(pTableName, lTableReference);
        }


        public void Add<T>(string pTableName, IEnumerable<object> pTableData)
        {
            InfoAPITableReference lTableReference = new InfoAPITableReference();
            lTableReference.table_name = pTableName;
            lTableReference.SetData<T>(pTableData);
            this.items.Add(lTableReference);
            this.ItemsDictionary.Add(pTableName, lTableReference);
        }


        public InfoAPITableReference GetTableReference(string pTableName)
        {
            return this.ItemsDictionary[pTableName];
        }


    }

}