﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace InfoAPIUniversalClient
{
    public class Command
    {
        public string CommandName;
        public Dictionary<string,string> Parameters;
        public string CommandLine;

        public Command (string CommandLine)
        {
            this.CommandLine = CommandLine;
            this.Parameters = new Dictionary<string, string>();

            string[] SplitLine = Regex.Split(CommandLine, "(?<=^[^\"]*(?:\"[^\"]*\"[^\"]*)*) (?=(?:[^\"]*\"[^\"]*\")*[^\"]*$)");
            int ParamCount = 0;
            foreach (string mItem in SplitLine)
            {
                if (mItem[0] == '-' || mItem[0] == '/')
                {
                    string[] SplitParam = mItem.Substring(1).Split('=');
                    this.Parameters.Add(SplitParam[0], SplitParam[1]);
                } else
                {
                    string mKey = ParamCount.ToString();
                    this.Parameters.Add(mKey, mItem);
                    ParamCount++;
                }

            }
            //this.Parameters = new List<string>(SplitLine);         

            this.CommandName = this.Parameters["0"].Trim();
            this.Parameters.Remove("0");
        }
    }
}
