﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InfoAPIUniversalClient
{
    public class CommandParser
    {
        private string[] _lines;
        private Int32 _command_index;
        public CommandParser(string pCommandFile)
        {
            if (File.Exists(pCommandFile))
            {
                this._lines = File.ReadAllLines(pCommandFile);
                this._command_index = 0;
            } else
            {
                throw new Exception("Command file '" + pCommandFile + "' does not exist!");
            }
        }

        public Command GetCommand()
        {
            Command CommandItem = null;
            do {
                if (this._command_index < this._lines.Count())
                {
                    string CommandLine = this._lines[this._command_index].Trim();
                    if (!string.IsNullOrEmpty(CommandLine) && CommandLine[0] != '#')
                    {
                        CommandItem = new Command(CommandLine);
                    }
                    this.Next();
                }
            } while (CommandItem == null && this._command_index < this._lines.Count());
            return CommandItem;

        }

        public void Next() {
            this._command_index++;
        }
    }
}
